#!/usr/bin/perl -w
use strict;

# main window
my $window;
my $frame_subfile;
my $frame_singlesub;
my $table;
my $table2;
my $table3;

#buttons
$main::button_shift=0;
$main::button_start=0;
$main::button_end=0;
my $button_quit;

#menus
my $menu_bar;
my $file_item;
my $tools_item;
my $help_item;

my $file_menu;
my $open_item;
$main::reread_item=0;
$main::save_item=0;
my $quit_item;

my $tools_menu;
$main::shift_item=0;

my $help_menu;
my $about_item;

#labels
my $label_name;
my $label_start;
my $label_end;
my $label_time;
my $label_subs;
$main::label_filename=0;

my $label_frames0;
my $label_frames1;
my $label_frames2;

my @data;

#adjusters
$main::adj_time=0;
$main::adj_start=0;
$main::adj_end=0;

#spinbuttons
my $spin_time;
my $spin_start;
my $spin_end;

# my $start;


my $scrolled_window;
$main::clist_subs = 0;

my $false = 0;
my $true = 1;

sub createGUI
{

	# basic stings
	$window = new Gtk::Window( "toplevel" );
	$frame_subfile = new Gtk::Frame( "Subtitle file" );
	$frame_singlesub = new Gtk::Frame( "Single subtitle" );
	$table = new Gtk::Table( 4, 1, $true );
	$table2 = new Gtk::Table( 5, 4, $true );
	$table3 = new Gtk::Table( 2, 3, $true );

	$window->set_default_size(400,400);

	# buttons
	$main::button_start = new Gtk::Button( "From selection" );
	$main::button_end = new Gtk::Button( "From selection" );
	$main::button_shift = new Gtk::Button( "Shift" );
	$button_quit = new Gtk::Button( "Quit" );

	# menus
	$menu_bar = new Gtk::MenuBar();
	$file_item = new Gtk::MenuItem( "File" );
	$tools_item = new Gtk::MenuItem( "Tools" );
	$help_item = new Gtk::MenuItem( "Help" );

	$file_menu = new Gtk::Menu();
	$open_item = new Gtk::MenuItem( "Open" );
	$main::reread_item = new Gtk::MenuItem( "Reload..." );
	$main::save_item = new Gtk::MenuItem( "Save" );
	$quit_item = new Gtk::MenuItem( "Quit" );

	$tools_menu = new Gtk::Menu();
	$main::shift_item = new Gtk::MenuItem( "Shift" );

	$help_menu = new Gtk::Menu();
	$about_item = new Gtk::MenuItem( "About" );

	# labels
	$main::label_filename = new Gtk::Label("Not loaded.");
	$label_name = new Gtk::Label("Subfile:");
	$label_start = new Gtk::Label("Start:");
	$label_end = new Gtk::Label("End:");
	$label_time = new Gtk::Label("Time:");
	$label_subs = new Gtk::Label("Subs:");

	$label_frames0 = new Gtk::Label("from frame");
	$label_frames1 = new Gtk::Label("to frame");
	$label_frames2 = new Gtk::Label("frames");

	$label_name->set_justify( "left" );
	$label_start->set_justify( "left" );
	$label_end->set_justify( "left" );
	$label_time->set_justify( "left" );
	$label_subs->set_justify( "left" );
	
	#adjustments to spin bittons
	$main::adj_time = new Gtk::Adjustment( 0,
                            -999999,
                            999999,
                            1,
                            1,
                            10 );

	$main::adj_start = new Gtk::Adjustment( 0,
                            0,
                            999999,
                            1,
                            1,
                            10 );

	$main::adj_end = new Gtk::Adjustment( 0,
                            0,
                            999999,
                            1,
                            1,
                            10 );
	#spinbuttons
	$spin_start = new Gtk::SpinButton($main::adj_start, 1.0, 0);
	$spin_end = new Gtk::SpinButton($main::adj_end, 1.0, 0);
	$spin_time = new Gtk::SpinButton($main::adj_time, 1.0, 0);

	# list	
	$scrolled_window = new Gtk::ScrolledWindow( undef, undef );
	$scrolled_window->set_policy( 'automatic', 'always' );
	$scrolled_window->show();

	$main::clist_subs = new_with_titles Gtk::CList( ("Start","Stop","Subtitle") );
	$main::clist_subs->set_selection_mode( "single" );
	
	# File menu
	$file_menu->append( $open_item );
	$file_menu->append( $main::reread_item );
	$file_menu->append( $main::save_item );
	$file_menu->append( $quit_item );

	$file_item->show();
	$file_item->set_submenu( $file_menu );

	$file_menu->show();

	#tools menu
	$tools_menu->append( $main::shift_item );
	$tools_item->show();
	$tools_item->set_submenu( $tools_menu );

	# Help menu
	$help_menu->append( $about_item );

	$help_item->show();
	$help_item->set_submenu( $help_menu );

	$menu_bar->show();

	# signal for menus
	$open_item->signal_connect( 'activate', \&fileOpen );
	$main::reread_item->signal_connect( 'activate', \&fileReread );
	$main::save_item->signal_connect( 'activate', \&fileSave );
	$quit_item->signal_connect( 'activate', \&quitProgram );
	$main::shift_item->signal_connect( 'activate', \&shifting );
	$about_item->signal_connect( 'activate', \&about );

	# build menu bar
	$open_item->show();
	$main::reread_item->show();
	$main::save_item->show();
	$quit_item->show();
	$main::reread_item->set_sensitive(0);
	$main::save_item->set_sensitive(0);

	$main::shift_item->show();
	$main::shift_item->set_sensitive(0);

	$about_item->show();


	# signals window
	$button_quit->signal_connect( "clicked", \&quitProgram );
	$main::button_shift->signal_connect( "clicked", \&shifting );
	$main::button_start->signal_connect( "clicked", \&toStart );
	$main::button_end->signal_connect( "clicked", \&toEnd );
	$window->signal_connect( "delete_event", \&quitProgram );
	$data[0] = $main::clist_subs;
        $main::clist_subs->signal_connect( "select_row", \&select_row, @data );
	
	# table
	my $xoptions = "shrink";
	my $yoptions = "shrink";
	my $xpadding = 0;
	my $ypadding = 0;
	$scrolled_window->add( $main::clist_subs );


	# whole sub file
        $table2->set_homogeneous( $true );

	$table2->attach( $label_name, 0, 1, 0, 1, $xoptions, $yoptions, $xpadding, $ypadding);
	$table2->attach( $main::label_filename, 1, 4, 0, 1, "expand", $yoptions, $xpadding, $ypadding);

	$table2->attach( $label_start, 0, 1, 1, 2, $xoptions, $yoptions, $xpadding, $ypadding );
	$table2->attach( $spin_start, 1, 2, 1, 2, "fill", $yoptions, $xpadding, $ypadding );
	$table2->attach( $label_frames0, 2, 3, 1, 2, $xoptions, $yoptions, $xpadding, $ypadding );
	$table2->attach( $main::button_start, 3, 4, 1, 2, $xoptions, $yoptions, $xpadding, $ypadding );

	$table2->attach( $label_end, 0, 1, 2, 3, $xoptions, $yoptions, $xpadding, $ypadding );
	$table2->attach( $spin_end, 1, 2, 2, 3, "fill", $yoptions, $xpadding, $ypadding );
	$table2->attach( $label_frames1, 2, 3, 2, 3, $xoptions, $yoptions, $xpadding, $ypadding );
	$table2->attach( $main::button_end, 3, 4, 2, 3, $xoptions, $yoptions, $xpadding, $ypadding );

	$table2->attach( $label_time, 0, 1, 3, 4, $xoptions, $yoptions, $xpadding, $ypadding );
	$table2->attach( $spin_time, 1, 2, 3, 4, "fill", $yoptions, $xpadding, $ypadding );
	$table2->attach( $label_frames2, 2, 3, 3, 4, $xoptions, $yoptions, $xpadding, $ypadding );

	$table2->attach( $main::button_shift, 2, 3, 4, 5, "fill", $yoptions, $xpadding, $ypadding );

	$frame_subfile->add($table2);

	# all
        $table3->set_homogeneous( $false );

	$table3->attach_defaults( $scrolled_window, 0, 3, 0, 1 );
	$table3->attach( $button_quit, 2, 3, 1, 2, "fill", $yoptions, $xpadding, $ypadding );


        $table->set_homogeneous( $false );

	$table->attach( $menu_bar, 0, 1, 0, 1, "fill", $yoptions, $xpadding, $ypadding);
	$table->attach_defaults( $frame_subfile, 0, 1, 1, 2);
	$table->attach_defaults( $frame_singlesub, 0, 1, 2, 3);
	$table->attach_defaults( $table3, 0, 1, 3, 4);



	$menu_bar->append($file_item);	
	$menu_bar->append($tools_item);	
	$menu_bar->append($help_item);	

	$button_quit->show();
	$main::button_shift->show();
	$main::button_start->show();
	$main::button_end->show();
	$main::button_shift->set_sensitive(0);

	$label_name->show();
	$main::label_filename->show();
	$label_start->show();
	$label_end->show();
	$label_time->show();
#	$label_subs->show();

	$spin_start->show();
	$spin_end->show();
	$spin_time->show();

	$label_frames0->show();
	$label_frames1->show();
	$label_frames2->show();

	$main::clist_subs->show();

	$frame_subfile->show();
	$frame_singlesub->show();

	$table->show();
	$table2->show();
	$table3->show();

	$window->border_width( 1 );
	$window->add( $table );
	$window->show();
}

1;
